import type { Agent, DidExchangeState, ConnectionType } from '@aries-framework/core';
import type { PropsWithChildren } from 'react';
import { ConnectionRecord } from '@aries-framework/core';
import * as React from 'react';
export declare type UseConnectionsOptions = {
    excludedTypes?: Array<ConnectionType | string>;
    connectionState?: DidExchangeState;
};
/**
 * This method retrieves the connection context for the current agent.
 * From this you can access all connection records for the agent.
 * @param options options for useConnections hook, lets us filter out specific types and limit states
 * @returns a connection context containing information about the agents connections
 */
export declare const useConnections: (options?: UseConnectionsOptions) => {
    records: ConnectionRecord[];
    loading?: boolean | undefined;
};
export declare const useConnectionById: (id: string) => ConnectionRecord | undefined;
interface Props {
    agent: Agent;
}
declare const ConnectionProvider: React.FC<PropsWithChildren<Props>>;
export default ConnectionProvider;
